
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java 理论与实践：嗨，我的线程到哪里去了？ / iVAN</title>

    <meta name="description" content="Java 理论与实践：嗨，我的线程到哪里去了？ 如果您不小心,线程可能会在没有(堆栈)跟踪的情况下从服务器应用程序中消失.在本文中,线程问题专家 Brian Goetz 提供了用于预防和检测线程&quot;擅离职守&quot;的技术. 当单线程应用程序中的主线程抛出一个未捕获的异常时,因为控制台中会打印堆栈跟踪(也因为程序停止),所以您很可能注意到.但在多线程应用程序中,尤其是在作为服务器运行并且不与控制台相连的应用程序中,线程死亡可能成为不太引人注目的事件,这会导致局部系统失败,从而产生混乱的应用程序行为. 在 Java theory an ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java 理论与实践：嗨，我的线程到哪里去了？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>如果您不小心，线程可能会在没有（堆栈）跟踪的情况下从服务器应用程序中消失。在本文中，线程问题专家 Brian Goetz 提供了用于预防和检测线程“擅离职守”的技术。 <br />当单线程应用程序中的主线程抛出一个未捕获的异常时，因为控制台中会打印堆栈跟踪（也因为程序停止），所以您很可能注意到。但在多线程应用程序中，尤其是在作为服务器运行并且不与控制台相连的应用程序中，线程死亡可能成为不太引人注目的事件，这会导致局部系统失败，从而产生混乱的应用程序行为。</p>
<p>在 Java theory and practice 十月份的专栏文章中，我们研究了线程池，并研究了编写得不正确的线程池会如何“泄漏”线程，直到最终丢失所有线程。大多数线程池实现通过捕获抛出的异常或重新启动死亡的线程来防止这一点，但线程泄漏的问题并不仅限于线程池 — 使用线程来为工作队列提供服务的服务器应用程序也可能具有这种问题。当服务器应用程序丢失了一个工作线程（worker thread）时，在较长时间内应用程序仍可能显得一切正常，这使得该问题的真实原因难以确定。</p>
<p>许多应用程序用线程来提供后台服务 — 处理来自事件队列的任务、从套接字读取命令或执行 UI 线程以外的长期任务。当由于抛出未捕获的 RuntimeException 或 Error，或者只是停下来，等待阻塞的 I/O 操作（原本未预计到阻塞），从而引起这些线程之一死亡时，会发生什么呢？</p>
<p>有时，譬如当线程执行由用户启动的长期任务（如拼写检查）时，用户会注意到任务没有进展，他们可能会异常终止操作或程序。但其它时间，后台线程执行“清理维护”任务 ，它们可能消失很长时间而不被察觉。</p>
<p>示例服务器应用程序<br />考虑这样一个假设的中间件服务器应用程序，它聚合来自各种输入源的消息，然后将它们提交到外部服务器应用程序，从外部应用程序接收响应并将响应路由回适当的输入源。对于每个输入源，都有一个以其自己的方式接受其输入消息的插件（通过扫描文件目录、等待套接字连接、轮询数据库表等）。插件可以由第三方编写，即使它们是在服务器 JVM 上运行的。这个应用程序拥有（至少）两个内部工作队列 — 从插件处接收的正在等待被发送到服务器的消息（“出站消息”队列），以及从服务器接收的正在等待被传递到适当插件的响应（“入站响应”队列）。通过调用插件对象上的服务例程 incomingResponse()，消息被路由到最初发出请求的插件。</p>
<p>从插件接收消息后，就被排列到出站消息队列中。由一个或多个从队列读取消息的线程处理出站消息队列中的消息、记录其来源并将它提交给远程服务器应用程序（假定通过 Web 服务接口）。远程应用程序最终通过 Web 服务接口返回响应，然后我们的服务器将接收的响应排列到入站响应队列中。一个或多个响应线程从入站响应队列读取消息并将其路由到适当的插件，从而完成往返“旅程”。</p>
<p>在这个应用程序中，有两个消息队列，分别用于出站请求和入站响应，不同的插件内可能也有另外的队列。我们还有几种服务线程，一个从出站消息队列读取请求并将其提交给外部服务器，一个从入站响应队列读取响应并将其路由到插件，在用于向套接字或其它外部请求源提供服务的插件中可能也有一些线程。</p>
<p>线程失败时并不总是显而易见的<br />如果这些线程中的一个（如响应分派线程）消失了，将会发生什么？因为插件仍能够提交新消息，所以它们可能不会立即注意到某些方面出错了。消息仍将通过各种输入源到达，并通过我们的应用程序提交到外部服务。因为插件并不期待立即获得其响应，因此它仍没有意识到出了问题。最后，接收的响应将排满队列。如果它们存储在内存中，那么最终将耗尽内存。即使不耗尽内存，也会有人在某个时刻发现响应得不到传递 — 但这可能需要一些时间，因为系统的其它方面仍能正常发挥作用。</p>
<p>当主要的任务处理方面由线程池而不是单个线程来处理时，对于偶然的线程泄漏的后果有一定程度的保护，因为一个执行得很好的八线程的线程池，用七个线程完成其工作的效率可能仍可以接受。起初，可能没有任何显著的差异。但是，系统性能最终将下降，虽然这种下降的方式不易被察觉。</p>
<p>服务器应用程序中的线程泄漏问题在于不是总是容易从外部检测它。因为大多数线程只处理服务器的部分工作负载，或可能仅处理特定类型的后台任务，所以当程序实际上遭遇严重故障时，在用户看来它仍在正常工作。这一点，再加上引起线程泄漏的因素并不总是留下明显痕迹，就会引起令人惊讶甚或使人迷惑的应用程序行为。</p>
<p>RuntimeException 是导致线程死亡的首要原因<br />当线程抛出未捕获的异常或错误时它们可能消失；而当线程等待的 I/O 操作永远不会完成，或没人为它们等待的监视器调用 notify() 时，它们只是停止工作。意外线程死亡的最常见根源是 RuntimeException（如 NullPointerException、ArrayIndexOutOfBoundsException 等）。在我们的示例应用程序中，在通过调用插件对象上的 incomingResponse() 将响应传递回插件时，可能抛出 RuntimeException。插件代码可能是由第三方编写的，或者可能是在编写完应用程序之后编写的，因此应用程序编写者不可能审核其正确性。如果一些插件抛出 RuntimeException 时某些响应服务线程会终止，这意味着一个出错的插件会使整个系统崩溃。遗憾的是，这种脆弱性很常见。</p>
<p>尽管编译器“希望”我们主动地针对已查出的异常编制代码（编译器会强制我们这样做），但大多数 Java 开发人员在很大程度上忽略了未查出的异常。在单线程应用程序中，未经处理的 RuntimeException 的结果很明显，并且对发生异常的位置有明确的堆栈跟踪，这提供了问题通知以及解决问题的有用信息。但是，在多线程应用程序中，由于未查出的异常，线程会无声无息地死亡 — 使得用户和开发人员对于发生的问题和为什么发生这些问题毫无头绪。</p>
<p>处理任务的线程（类似于示例应用程序中的请求和响应处理程序），基本上花费其整个生命周期穿过某个类似于 Runnable 的抽象障碍物来调用服务方法。因为我们不知道在这个抽象障碍物的另一边是什么，所以，对于服务方法，我们应该怀疑，它是不是真好到可以假设它从不抛出未查出异常的程度。如果服务例程抛出 RuntimeException，则调用线程应该捕获这个异常，并将它记录到日志，然后转到队列中的下一项或关闭线程然后再重新启动它。（后一个选项源自这样的假定：任何抛出 RuntimeException 或 Error 的代码也可能已经破坏了线程的状态。）</p>
<p>清单 1 中的代码是典型的从工作队列处理 Runnable 任务的线程，类似于我们的示例中的入站响应线程。它并不防备抛出任何未查出异常的插件。</p>
<p>清单 1. 不防备 RuntimeException 的工作线程 <br />private class TrustingPoolWorker extends Thread {<br />    public void run() {<br />        IncomingResponse ir;</p>
<p>while (true) {<br />            ir = (IncomingResponse) queue.getNext();<br />            PlugIn plugIn = findPlugIn(ir.getResponseId());<br />            if (plugIn != null)<br />                plugIn.handleMessage(ir.getResponse());<br />            else<br />                log("Unknown plug-in for response " + ir.getResponseId());<br />        }<br />    }<br />}</p>
<p>我们不必添加许多代码来使这个工作线程能够更健壮地处理插件代码中的故障。只要通过捕获 RuntimeException，然后进行纠正操作，就可以确保我们自己有能力防止一个编写得较差的插件破坏整个服务器。适当的纠正操作应该将错误记录到日志，然后，简单地转到下一条消息，终止当前线程并重新启动它（这是类似于 TimerTask 的类的做法），或者卸载引起问题的插件，如清单 2 中所示：</p>
<p>清单 2. 防备 RuntimeException 的工作线程 <br />private class SaferPoolWorker extends Thread {<br />    public void run() {<br />        IncomingResponse ir;</p>
<p>while (true) {<br />            ir = (IncomingResponse) queue.getNext();<br />            PlugIn plugIn = findPlugIn(ir.getResponseId());<br />            if (plugIn != null) {<br />        try {<br />                    plugIn.handleMessage(ir.getResponse());<br />                }<br />                catch (RuntimeException e) {<br />                    // Take some sort of action; <br />                    // - log the exception and move on<br />                    // - log the exception and restart the worker thread<br />                    // - log the exception and unload the offending plug-in<br />                }<br />            }<br />            else<br />                log("Unknown plug-in for response " + ir.getResponseId());<br />        }<br />    }<br />}</p>
<p>使用由 ThreadGroup 提供的未捕获的异常处理程序<br />除了将外来代码视作较可能抛出 RuntimeException 的方法之外，使用 ThreadGroup 类的 uncaughtException 函数也是明智的。ThreadGroup 用处不很大，但是目前（直到 JDK 1.5 中的 Thread 添加了未捕获的异常处理为止），uncaughtException 特性暂时使它不可或缺。清单 3 展示了一个示例，使用 ThreadGroup 来检测由于未捕获的异常引起的线程死亡。</p>
<p>清单 3. 使用 uncaughtException 来检测线程死亡 <br />public class ThreadGroupExample {</p>
<p>public static class MyThreadGroup extends ThreadGroup {</p>
<p>public MyThreadGroup(String s) {<br />            super(s);<br />        }</p>
<p>public void uncaughtException(Thread thread, Throwable throwable) {<br />            System.out.println("Thread " + thread.getName() <br />              + " died, exception was: ");<br />            throwable.printStackTrace();<br />        }<br />    }</p>
<p>public static ThreadGroup workerThreads = <br />      new MyThreadGroup("Worker Threads");</p>
<p>public static class WorkerThread extends Thread {<br />        public WorkerThread(String s) {<br />            super(workerThreads, s);<br />        }</p>
<p>public void run() {<br />            throw new RuntimeException();<br />        }</p>
<p>}</p>
<p>public static void main(String[] args) {<br />        Thread t = new WorkerThread("Worker Thread");<br />        t.start();<br />    }<br />}</p>
<p>如果线程组中的一个线程因抛出一个未捕获的异常而死亡，则调用该线程组的 uncaughtException() 方法，该方法可以向日志写入一条记录、重新启动线程，然后重新启动系统，或采取它认为必要的任何纠正或诊断操作。至少，如果在线程死亡时所有线程都写一条日志消息，您将有一个何时、何处出错的记录，而不是只能奇怪您的请求处理线程到哪里去了。</p>
<p>结束语<br />当线程从应用程序中消失时会引起混乱，并且在很多情况下，线程消失时没有（堆栈）跟踪。象对付许多风险一样，防止线程泄漏的最佳方法是预防和检测相结合；注意有可能抛出 RuntimeException 的地方（如调用外来代码时），并使用 ThreadGroup 提供的 uncaughtException 处理程序来在线程异常终止时进行检测。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:03:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e7%a8%8b%e5%ba%8f/" title="应用程序">应用程序</a>, <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%bc%82%e5%b8%b8/" title="异常">异常</a>, <a href="https://www.iamivan.net/tag/%e9%98%9f%e5%88%97/" title="队列">队列</a>, <a href="https://www.iamivan.net/tag/linux-%e7%ba%bf%e7%a8%8b-%e5%bc%82%e5%b8%b8/" title="linux&period; 线程  异常">linux&period; 线程  异常</a>, <a href="https://www.iamivan.net/tag/runtimeexception/" title="runtimeexception">runtimeexception</a>, <a href="https://www.iamivan.net/tag/java%e5%a4%9a%e7%ba%bf%e7%a8%8b%e5%bc%82%e5%b8%b8/" title="java多线程异常">java多线程异常</a>, <a href="https://www.iamivan.net/tag/thread-%e6%96%b9%e9%9d%a2%e7%9a%84%e9%97%ae%e9%a2%98/" title="thread 方面的问题">thread 方面的问题</a>, <a href="https://www.iamivan.net/tag/%e6%b6%88%e6%81%af%e6%8e%a5%e6%94%b6%e6%98%be%e7%a4%ba%e6%b7%b7%e4%b9%b1/" title="消息接收显示混乱">消息接收显示混乱</a>, <a href="https://www.iamivan.net/tag/%e5%a0%86%e6%a0%88%e4%b8%8e%e9%98%9f%e5%88%97/" title="堆栈与队列">堆栈与队列</a>, <a href="https://www.iamivan.net/tag/%e6%9c%aa%e6%8d%95%e8%8e%b7%e5%bc%82%e5%b8%b8/" title="未捕获异常">未捕获异常</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java 理论与实践：嗨，我的线程到哪里去了？的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGjR4vp.html" rel="bookmark">Java理论与实践&colon; 嗨，我的线程到哪里去了？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当单线程应用程序中的主线程抛出一个未捕获的异常时,因为控制台中会打 印堆栈跟踪(也因为程序停止),所以您很可能注意到.但在多线程应用程序中 ,尤其是在作为服务器运行并且不与控制台相连的应用程序中,线程死亡可能成 为不太引人注目的事件,这会导致局部系统失败,从而产生混乱的应用程序行为 . 在 Java theory and practice十月份的专栏文章 中,我们研究了线程池, 并研究了编写得不正确的线程池会如何&quot;泄漏&quot;线程,直到最终丢失所有线程. 大多数线程池实现通过捕获抛出的异常或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wPaLp.html" rel="bookmark">Java理论与实践专题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java理论与实践: JDK 5.0中更灵活.更具可伸缩性的锁定机制 Java理论和实践: 一个有缺陷的微基准的剖析 Java理论和实践: 理解JTS ― 平衡安全性和性能 Java理论和实践: 理解JTS ― 幕后魔术 Java理论和实践: 安全构造技术 Java理论与实践: 平衡测试,第3部分:用方面检验设计约束 Java理论与实践:平衡测试,第2部分:编写和优化bug检测器 Java理论与实践:平衡测试,第1部分:不要仅编写测试,还要编写bu Java理论与实践: 您的小数点到哪里去了?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqNYRp.html" rel="bookmark">Java 理论与实践：变还是不变？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不变对象具有许多能更方便地使用它们的特性,包括不严格的同步需求和不必考虑数据讹误就能自由地共享和高速缓存对象引用.尽管不变性可能未必对于所有类都有意义,但大多数程序中至少有一些类将受益于不可变.在本月的 Java 理论与实践中,Brian Goetz 说明了不变性的一些长处和构造不变类的一些准则.请在附带的论坛中与作者和其他读者分享您关于本文的心得.(也可以单击文章顶部或底部的&quot;讨论&quot;来访问论坛.) 不变对象是指在实例化后其外部可见状态无法更改的对象.Java 类库中的 String.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOoE9z.html" rel="bookmark">Java 理论与实践&colon; JDK 5&period;0 中更灵活、更具可伸缩性的锁定机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				伸缩 内容: synchronized 快速回顾 对 synchronized 的改进 比较 ReentrantLock 和 synchronized 的可伸缩性 条件变量 这不公平 结束语 参考资料 关于作者 对本文的评价 相关内容: Java 理论与实践 系列 Synchronization is not the enemy Reducing contention IBM developer kits for the Java platform (downloads) 订阅: develop			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj753WM.html" rel="bookmark">Java理论与实践&colon; 构建一个更好的HashMap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ConcurrentHashMap 是 Doug Lea的 util.concurrent 包的一部分,它提供 比Hashtable 或者 synchronizedMap 更高程度的并发性.而且,对于大多数成 功的 get() 操作它会设法避免完全锁定,其结果就是使得并发应用程序有着非 常好的吞吐量.这个月,BrianGoetz 仔细分析了 ConcurrentHashMap的代码, 并探讨 Doug Lea 是如何在不损失线程安全的情况下取得这么骄人成绩的. 在7月份的那期 Java理论与实践			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAajWXM.html" rel="bookmark">Java理论与实践&colon; 消除bug</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多有关编程风格的建议都是为了创建高质量.可维护的代码,这很合理, 因为最容易修复 bug 的时间就是在产生 bug 之前(少量的预防措施--).遗 憾的是,只预防往往是不够的,虽然有一些精巧的工具可以帮助您创建好的代码 ,但是很少有工具可以帮助您分析.维护或提高现有代码的质量. 写线程安全的类很难,而分析现有类的线程安全性更难,增强类使其仍然保 持线程安全也很难.以隐含假定.不变式以及预期用例(虽然在开发人员的头脑 中很清晰,但是没有以设计笔记.注释或者文档的方式记录下来)的方式编写完 类之后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bElRBAz.html" rel="bookmark">Java理论与实践&colon; 修复Java内存模型，第1部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				活跃了将近三年的 JSR 133,近期发布了关于如何修复 Java 内存模型 (Java Memory Model, JMM)的公开建议.原始 JMM 中有几个严重缺陷,这导 致了一些难度高得惊人的概念语义,这些概念原来被认为很简单,如 volatile .final 以及 synchronized.在这一期的 Java 理论与实践 中,Brian Goetz 展示了如何加强 volatile 和 final 的语义,以修复 JMM.这些更改有些已经 集成在 JDK 1.4 中:而另一些将会包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxEvob.html" rel="bookmark">Java理论与实践&colon;做个好的（事件）侦听器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				观察者模式在 Swing 开发中很常见,在 GUI 应用程序以外的场景中,它对 于消除组件的耦合性也非常有用.但是,仍然存在一些侦听器登记和调用方面的 常见缺陷.在 Java 理论与实践 的这一期中,Java 专家 Brian Goetz 就如何 做一个好的侦听器,以及如何对您的侦听器也友好,提供了一些感觉很好的建议 .请在相应的 讨论论坛 上与作者和其他读者分享您对这篇文章的想法.(您也 可以单击本文顶部或底部的 讨论 访问论坛.) Swing 框架以事件侦听器的形式广泛利用了观察者模式(也称			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPNaXlb.html" rel="bookmark">Java理论和实践&colon; 安全构造技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 语言提供了灵活的.看上去很简单的线程功能,使得您很容易在您的应用程序中使用多线程.然而,Java应用程序中的并发编程比看上去要复杂:在 Java 程序中,有一些微妙(也许并不是那么微妙)方式会造成数据争用(data race)以及并发问题.在这篇 Java 理论和实践中,Brian探讨了一个常见的线程方面的危险:在构造过程中,允许 this 引用逃脱(escape).这个看上去没有什么危害的做法可以在 Java 程序中造成无法可预料和不期望的结果. 测试和调试多线程程序是极其困难的,因			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZZB6z.html" rel="bookmark">Java 理论与实践&colon; 非阻塞算法简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[本文转载自Java 理论与实践: 非阻塞算法简介]Java 5.0 第一次让使用 Java 语言开发非阻塞算法成为可能,java.util.concurrent 包充分地利用了这个功能.非阻塞算法属于并发算法,它们可以安全地派生它们的线程,不通过锁定派生,而是通过低级的原子性的硬件原生形式 -- 例如比较和交换.非阻塞算法的设计与实现极为困难,但是它们能够提供更好的吞吐率,对生存问题(例如死锁和优先级反转)也能提供更好的防御.在这期的 Java 理论与实践 中,并发性大师 Brian Goet			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm69Bz.html" rel="bookmark" class="title">Linux  命令大全-网络资源</a>
					<div>
						Linux  命令大全 地址: http://man.linuxde.net/ 说明: 包括网络.系统等命令查询---备查询.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOmwQM.html" rel="bookmark" class="title">杂记乱弹20140826</a>
					<div>
						    突然发现不写挨踢文章竟然不知道写些神马鸟!一根筋似的单纯小脑瓜能不能一路过关斩将笑傲江湖到最后,这个还真不好说呢?不过从概率学上说恐怕期望不高呀!活到现在眼界没怎么开阔,知识老是原地踏步,怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvaW5b.html" rel="bookmark" class="title">网页报表研究</a>
					<div>
						网页 经过查找资料和研究其他网页的实现方法,以下是我认为的网页报表原理和解决方案,以及他们之间的优缺点. 一:总的原理 1． 利用Activex 报表控件直接读取页面内容,通过控件的一些方法即时生成报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYn5lp.html" rel="bookmark" class="title">在C&num;里面调用带有回调函数和自定义结构体的DLL的例程</a>
					<div>
						函数 开发环境: WinXP Pro(SP2英文版) + VS.NET 2003中文版接口库版本: CMPP2.0 API第二版(V2.6) 该例程演示了如何在C#里面调用VC6.0开发的带回调函数的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo67Pdz.html" rel="bookmark" class="title">高性能的MySQL（1）锁和MVCC</a>
					<div>
						一.MySQL逻辑架构 二.锁 1.读写锁 读锁是共享的,是互相不阻塞的,多个客户在同一时间读取同一资源,互补干扰.写锁是排他的,会阻塞其他的写锁和读锁. 2.隐式和显式锁定 隐式:InnoDB,在执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxOAob.html" rel="bookmark" class="title">正式版Windows 7预计10月份发布</a>
					<div>
						[CSDN消息]据国外媒体报道,微软周二确认称,该公司计划于10月22日在零售店铺中出售Windows 7,同时开始在新PC上预装这一操作系统. 微软高级副总裁比尔维迪(Bill Veghte)在今天 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKxe6M.html" rel="bookmark" class="title">打开Excel出现宏怎么解决？</a>
					<div>
						先来看看弹窗吧: 方法一.一般是用户将excel安全级别设置成高了.我们直接将其安全级别更改为中的等级即可.点击菜单栏菜单'工具'-选项-安全性-宏安全性,将安全等级调到中,那样打开就可以了.现在去打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7qQgb.html" rel="bookmark" class="title">网站建设中哪些顾客最在意？</a>
					<div>
						  在网站建设行业里,每个公司说起理论的时候都是一套一套的,他们都认为顾客一般都是重视网站功能.安全性以及售后服务,做网站公司就将这些摆在了网站建设服务的第一位.只要有过和顾客沟通的经验,都会发现我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKLvJM.html" rel="bookmark" class="title">Mac键盘如何开启F1 - F12功能键</a>
					<div>
						  首先在系统桌面的左上角点击苹果图标,找到&quot;系统偏好设置&quot;,点击打开&quot;系统偏好设置&quot;面板,如图所示. 在打开的&quot;系统偏好设置&quot;面板里的&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P9QVp.html" rel="bookmark" class="title">Azure主要组件有哪些及相关应用</a>
					<div>
						问题描述 Azure主要组件有哪些及相关应用 Azure主要组件有哪些及相关应用 Azure主要组件有哪些及相关应用 解决方案 包括Windows Azure.SQL Azure.Windows Az ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN76kWp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;&sol;&rdquo;应用程序中的服务器错误。索引超出了数组界限。</a>
					<div>
						问题描述 &quot;/&quot;应用程序中的服务器错误.索引超出了数组界限. &quot;/&quot;应用程序中的服务器错误. 索引超出了数组界限. 说明: 执行当前 Web 请求期间,出现未处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXDRxz.html" rel="bookmark" class="title">SHA-1遭彻底破解！Windows XP用户很遭殃</a>
					<div>
						SHA-1(安全哈希算法)在许多加密安全协议中广泛使用,包括TLS和SSL.PGP.SSH.S/MIME和IPsec,通常我们在从网上下载一些镜像和重要文件的时候(甚至软件自更新时的校验),也会比对M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKAQqb.html" rel="bookmark" class="title">有没有必要将网站Div&plus;Css重构？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 搜索引擎营销工作中,几乎次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY16Zp.html" rel="bookmark" class="title">c语言建立二叉树怎么输入多组数据</a>
					<div>
						问题描述 c语言建立二叉树怎么输入多组数据 #include #include typedef struct BiTNode { char data; struct BiTNode *lchild,* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rB1wz.html" rel="bookmark" class="title">struts2 3 15-Struts2&period;2升级到2&period;3&period;15 启动时出错，能帮看下是什么原因不</a>
					<div>
						问题描述 Struts2.2升级到2.3.15 启动时出错,能帮看下是什么原因不 [ERROR]: [2013-12-02 20:30:41] com.opensymphony.xwork2.util ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX4D1z.html" rel="bookmark" class="title">CSS Sprite雪碧图使用场景-慕课网</a>
					<div>
						来源:http://www.imooc.com/video/1317#0-hi-1-36977-89fdc647f52c5196c0d5da60d38d89ea					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rWjjp.html" rel="bookmark" class="title">小心！苹果已开始侦测禁用越狱iPhone</a>
					<div>
						对于http://www.aliyun.com/zixun/aggregation/9479.html&quot;&gt;iOS越狱阵营的存在,苹果一直心知肚明,但除了每次升级系统封堵越狱漏洞外,却也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR8Vmb.html" rel="bookmark" class="title">域名选择的六大技巧</a>
					<div>
						域名选择的六大技巧                                                        --大财主                               ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWvrEz.html" rel="bookmark" class="title">什么是YUV、RGB？</a>
					<div>
						由来 通常我们用RGB表示一种彩色.计算机系统里的LCD显示的数据就是RGB来表示每个像素的颜色.而在我们生活里,有黑白电视机与彩色电视机两种,拍摄节目源时不可以用两种不同的摄像机来存放两种图像数据. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB0NZM.html" rel="bookmark" class="title">环保部门称天线辐射基本无害</a>
					<div>
						去年,上海市委大楼引进了通讯基站(资料图片) 省环保厅回应电磁辐射安全质疑 通信基站搭建在居民楼楼顶.变电站修在了居民小区,到底这些设备有没有电磁污染.会不会对人体造成伤害?每个月,环保部门都会接到这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmB255z.html" rel="bookmark" class="title">关于equals&lpar;&rpar;</a>
					<div>
						问题描述 StringBuffer a=new StringBuffer(&quot;a&quot;); StringBuffer b=new StringBuffer(&quot;a&quot;); ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZroop.html" rel="bookmark" class="title">Rackspace季报解读：OpenStack公有云需求放缓</a>
					<div>
						[译者的话]: Rackspace的2015年第三季度财报依然好于分析师预期.在接连与亚马逊AWS和微软Azure达成战略合作协议后,&quot;多云战略&quot;成为Rackspace面向未来企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg08OM.html" rel="bookmark" class="title">url-python爬虫读不出网站代码的问题</a>
					<div>
						问题描述 python爬虫读不出网站代码的问题 import urllib import urllib2 page=1 url='http://www.qiushibaike.com/hot/page ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKRenp.html" rel="bookmark" class="title">php中对用户信息进行更新执行mysql语句时update无法正确更新</a>
					<div>
						问题描述 php中对用户信息进行更新执行mysql语句时update无法正确更新 这是代码 这个更新语句不知道有没有什么问题 第一个是打印出update的执行结果 是true 证明sql语句能运行,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myea1dM.html" rel="bookmark" class="title">个人站长运营网站须明确网站服务内容，踏踏实实为用户服务</a>
					<div>
						摘要: 3.15已经过去了,但作为互联网中重要的角色个人网站如何才能够赢得更多消费者的支持呢?昨天在游览互联网新闻的时候发现知名的当当网所卖出的苹果手机竟然是返修机,知名网站尚 3.15已经过去了,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Qnkz.html" rel="bookmark" class="title">TLC并非一无是处 短命芯片或助力数据中心</a>
					<div>
						此前天极网服务器频道的&lt;http://www.aliyun.com/zixun/aggregation/15579.html&quot;&gt;固态硬盘发展之殇:渐行渐远的企业存储方案&gt;一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW3Kkz.html" rel="bookmark" class="title">Git&commat;OSC 项目演示新增接入百度 BAE 平台</a>
					<div>
						Git@OSC 面世已经将近三年,致力于为国内的开发者提供一个快速可靠的代码托管服务:同时我们也在不断接入优秀的第三方服务提供商,来为用户提供方便好用的一键部署功能.目前已经有 CF 平台的MoPaa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnnX3p.html" rel="bookmark" class="title">在ASP编程中使用数组&lowbar;应用技巧</a>
					<div>
						数组的定义 Dim MyArray MyArray = Array(1,5,123,12,98) 可扩展数组 Dim MyArray() for i = 0 to 10 ReDim Preserve  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1Yw0b.html" rel="bookmark" class="title">监控 log文件大小的存储过程&lowbar;MsSql</a>
					<div>
						1.监控log文件大小超过10g的server 和db 复制代码 代码如下: create procedure db_sendmail_mssqllogsize as declare @sql var ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWP98M.html" rel="bookmark" class="title">施耐德电气Galaxy VX发布 ，自带多项&OpenCurlyDoubleQuote;黑科技&rdquo;</a>
					<div>
						位于厦门市同安区的施耐德电气信息技术(厦门)有限公司是施耐德电气在中国最主要的电源制造生产基地,施耐德电气在中国市场销售的UPS绝大部分就来自于这个工厂.得益于中国经济的快速发展,中国已经成为施耐德电 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
